Index: LMDZ6/trunk/libf/phylmd/cloudth_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/cloudth_mod.F90	(revision 3998)
+++ LMDZ6/trunk/libf/phylmd/cloudth_mod.F90	(revision 3999)
@@ -1534,4 +1533,880 @@
 
 END SUBROUTINE cloudth_v6
+
+
+
+
+
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+SUBROUTINE cloudth_mpc(klon,klev,ind2,mpc_bl_points,                     &
+&           temp,ztv,po,zqta,fraca,zpspsk,paprs,pplay,ztla,zthl,            &
+&           ratqs,zqs,snowflux,qcloud,qincloud,icefrac,ctot,ctot_vol)
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+! Author : Arnaud Octavio Jam (LMD/CNRS), Etienne Vignon (LMDZ/CNRS)
+! Date: Adapted from cloudth_vert_v3 in 2021
+! Aim : computes qc and rneb in thermals with cold microphysical considerations
+!       + for mixed phase boundary layer clouds, calculate ql and qi from 
+!       a stationary MPC model
+! IMPORTANT NOTE: we assume iflag_clouth_vert=3
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+
+      USE ioipsl_getin_p_mod, ONLY : getin_p
+      USE phys_output_var_mod, ONLY : cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv
+      USE lscp_tools_mod, ONLY: CALC_QSAT_ECMWF, ICEFRAC_LSCP
+      USE phys_local_var_mod, ONLY : qlth, qith
+
+      IMPLICIT NONE
+
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+#include "thermcell.h"
+#include "nuage.h"
+      
+
+!------------------------------------------------------------------------------
+! Declaration
+!------------------------------------------------------------------------------
+
+! INPUT/OUTPUT
+
+      INTEGER, INTENT(IN)                         :: klon,klev,ind2
+      INTEGER, DIMENSION(klon,klev), INTENT(INOUT)   ::  mpc_bl_points ! 1 where BL MPC, 0 otherwise
+
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  temp          ! Temperature [K]
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  ztv           ! Virtual potential temp [K]
+      REAL, DIMENSION(klon),      INTENT(IN)      ::  po            ! specific humidity [kg/kg]
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  zqta          ! specific humidity within thermals [kg/kg]
+      REAL, DIMENSION(klon,klev+1), INTENT(IN)    ::  fraca         ! Fraction of the mesh covered by thermals [0-1] 
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  zpspsk
+      REAL, DIMENSION(klon,klev+1), INTENT(IN)    ::  paprs         ! Pressure at layer interfaces [Pa]
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  pplay         ! Pressure at the center of layers [Pa]
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  ztla          ! Liquid temp [K]
+      REAL, DIMENSION(klon,klev), INTENT(INOUT)      ::  zthl       ! Liquid potential temp [K]
+      REAL, DIMENSION(klon,klev), INTENT(IN)      ::  ratqs         ! Parameter that determines the width of the total water distrib.
+      REAL, DIMENSION(klon),      INTENT(IN)      ::  zqs           ! Saturation specific humidity in the mesh [kg/kg]
+      REAL, DIMENSION(klon,klev+1), INTENT(IN)    ::  snowflux      ! snow flux at the interface of the layer [kg/m2/s]
+
+
+      REAL, DIMENSION(klon,klev), INTENT(OUT)      ::  ctot         ! Cloud fraction [0-1]
+      REAL, DIMENSION(klon,klev), INTENT(OUT)      ::  ctot_vol     ! Volume cloud fraction [0-1]
+      REAL, DIMENSION(klon),      INTENT(OUT)      ::  qcloud       ! In cloud total water content [kg/kg] 
+      REAL, DIMENSION(klon),      INTENT(OUT)      ::  qincloud       ! In cloud condensed water content [kg/kg] 
+      REAL, DIMENSION(klon,klev), INTENT(OUT)      ::  icefrac      ! Fraction of ice in clouds [0-1]
+
+
+! LOCAL VARIABLES
+
+      INTEGER itap,ind1,l,ig,iter,k 
+      LOGICAL flag_topthermals
+
+
+      REAL zqsatth(klon,klev), zqsatenv(klon,klev)
+      REAL sigma1(klon,klev)                                                         
+      REAL sigma2(klon,klev)
+      REAL qcth(klon,klev)
+      REAL qcenv(klon,klev)
+      REAL qctot(klon,klev) 
+      REAL cth(klon,klev)
+      REAL cenv(klon,klev)   
+      REAL cth_vol(klon,klev)
+      REAL cenv_vol(klon,klev)
+      REAL rneb(klon,klev)
+      REAL zqenv(klon)   
+
+      REAL qsatmmussig1,qsatmmussig2,sqrtpi,sqrt2,sqrt2pi,pi
+      REAL rdd,cppd,Lv
+      REAL alth,alenv,ath,aenv
+      REAL sth,senv,sigma1s,sigma2s,sigma1s_fraca,sigma1s_ratqs
+      REAL inverse_rho,beta,a_Brooks,b_Brooks,A_Maj_Brooks,Dx_Brooks,f_Brooks
+      REAL xth,xenv,exp_xenv1,exp_xenv2,exp_xth1,exp_xth2
+      REAL xth1,xth2,xenv1,xenv2,deltasth, deltasenv
+      REAL IntJ,IntI1,IntI2,IntI3,IntJ_CF,IntI1_CF,IntI3_CF,coeffqlenv,coeffqlth
+      REAL Tbef,zdelta,qsatbef,zcor
+      REAL qlbef,dqsatdt
+      REAL erf
+      REAL zpdf_sig(klon),zpdf_k(klon),zpdf_delta(klon)
+      REAL zpdf_a(klon),zpdf_b(klon),zpdf_e1(klon),zpdf_e2(klon) 
+      REAL rhodz(klon,klev)
+      REAL zrho(klon,klev)
+      REAL dz(klon,klev)
+      REAL qslth, qsith, qslenv, alenvl, aenvl
+      REAL sthi, sthl, althl, athl
+      REAL senvi, senvl, qbase, sbase, qliqth, qiceth
+      REAL qimax, ttarget, stmp, cout, coutref
+      REAL maxi, mini, pas, temp_lim
+      REAL deltazlev_mpc(klev),qth_mpc(klev), temp_mpc(klev), pres_mpc(klev), fraca_mpc(klev+1), snowf_mpc(klev+1)
+
+      INTEGER, SAVE :: niter=20
+
+      ! Modifty the saturation deficit PDF in thermals 
+      ! in the presence of ice crystals
+      REAL,SAVE :: C_mpc
+      !$OMP THREADPRIVATE(C_mpc)
+      ! Change the width of the PDF used for vertical subgrid scale heterogeneity
+      ! (J Jouhaud, JL Dufresne, JB Madeleine)
+      REAL,SAVE :: vert_alpha, vert_alpha_th
+      !$OMP THREADPRIVATE(vert_alpha, vert_alpha_th)
+      REAL,SAVE :: sigma1s_factor=1.1
+      REAL,SAVE :: sigma1s_power=0.6
+      REAL,SAVE :: sigma2s_factor=0.09
+      REAL,SAVE :: sigma2s_power=0.5
+      REAL,SAVE :: cloudth_ratqsmin=-1.
+      !$OMP THREADPRIVATE(sigma1s_factor,sigma1s_power,sigma2s_factor,sigma2s_power,cloudth_ratqsmin)
+      INTEGER, SAVE :: iflag_cloudth_vert_noratqs=0
+      !$OMP THREADPRIVATE(iflag_cloudth_vert_noratqs)
+      LOGICAL, SAVE :: firstcall = .TRUE.
+      !$OMP THREADPRIVATE(firstcall)
+
+      CHARACTER (len = 80) :: abort_message
+      CHARACTER (len = 20) :: routname = 'cloudth_mpc'
+
+
+!------------------------------------------------------------------------------
+! Initialisation
+!------------------------------------------------------------------------------
+
+
+! Few initial checksS
+
+      IF (iflag_cloudth_vert.NE.3) THEN
+         abort_message = 'clouth_mpc cannot be used if iflag_cloudth_vert .NE. 3'
+         CALL abort_physic(routname,abort_message,1)
+      ENDIF
+
+      DO k = 1,klev
+      DO ind1 = 1, klon
+        rhodz(ind1,k) = (paprs(ind1,k)-paprs(ind1,k+1))/rg !kg/m2
+        zrho(ind1,k) = pplay(ind1,k)/temp(ind1,k)/rd !kg/m3
+        dz(ind1,k) = rhodz(ind1,k)/zrho(ind1,k) !m : epaisseur de la couche en metre
+      END DO
+      END DO
+
+
+      sigma1(:,:)=0.
+      sigma2(:,:)=0.
+      qcth(:,:)=0.
+      qcenv(:,:)=0.  
+      qctot(:,:)=0.
+      qlth(:,ind2)=0.
+      qith(:,ind2)=0.
+      rneb(:,:)=0.
+      qcloud(:)=0.
+      cth(:,:)=0.
+      cenv(:,:)=0.
+      ctot(:,:)=0.
+      cth_vol(:,:)=0.
+      cenv_vol(:,:)=0.
+      ctot_vol(:,:)=0.
+      qsatmmussig1=0.
+      qsatmmussig2=0.
+      rdd=287.04
+      cppd=1005.7
+      pi=3.14159 
+      sqrt2pi=sqrt(2.*pi)
+      sqrt2=sqrt(2.)
+      sqrtpi=sqrt(pi)
+      icefrac(:,ind2)=0.
+
+
+
+      IF (firstcall) THEN
+
+        vert_alpha=0.5
+        CALL getin_p('cloudth_vert_alpha',vert_alpha)
+        WRITE(*,*) 'cloudth_vert_alpha = ', vert_alpha
+        ! The factor used for the thermal is equal to that of the environment
+        !   if nothing is explicitly specified in the def file
+        vert_alpha_th=vert_alpha
+        CALL getin_p('cloudth_vert_alpha_th',vert_alpha_th)
+        WRITE(*,*) 'cloudth_vert_alpha_th = ', vert_alpha_th
+        ! Factor used in the calculation of sigma1s
+        CALL getin_p('cloudth_sigma1s_factor',sigma1s_factor)
+        WRITE(*,*) 'cloudth_sigma1s_factor = ', sigma1s_factor
+        ! Power used in the calculation of sigma1s
+        CALL getin_p('cloudth_sigma1s_power',sigma1s_power)
+        WRITE(*,*) 'cloudth_sigma1s_power = ', sigma1s_power
+        ! Factor used in the calculation of sigma2s
+        CALL getin_p('cloudth_sigma2s_factor',sigma2s_factor)
+        WRITE(*,*) 'cloudth_sigma2s_factor = ', sigma2s_factor
+        ! Power used in the calculation of sigma2s
+        CALL getin_p('cloudth_sigma2s_power',sigma2s_power)
+        WRITE(*,*) 'cloudth_sigma2s_power = ', sigma2s_power
+        ! Minimum value for the environmental air subgrid water distrib
+        CALL getin_p('cloudth_ratqsmin',cloudth_ratqsmin)
+        WRITE(*,*) 'cloudth_ratqsmin = ', cloudth_ratqsmin
+        ! Remove the dependency to ratqs from the variance of the vertical PDF
+        CALL getin_p('iflag_cloudth_vert_noratqs',iflag_cloudth_vert_noratqs)
+        WRITE(*,*) 'iflag_cloudth_vert_noratqs = ', iflag_cloudth_vert_noratqs
+        ! Modifies the PDF in thermals when ice crystals are present
+        C_mpc=1.e2
+        CALL getin_p('C_mpc',C_mpc)
+        WRITE(*,*) 'C_mpc = ', C_mpc
+
+        firstcall=.FALSE.
+
+      ENDIF
+
+
+
+!-------------------------------------------------------------------------------
+! Identify grid points with potential mixed-phase conditions
+!-------------------------------------------------------------------------------
+
+      temp_lim=RTT-40.0
+
+      DO ind1=1,klon
+            IF ((temp(ind1,ind2) .LT. RTT) .AND. (temp(ind1,ind2) .GT. temp_lim) &
+            .AND. (iflag_mpc_bl .GE. 2) .AND. (ind2<=klev-2)  &
+            .AND. (ztv(ind1,1).GT.ztv(ind1,2)) .AND.(fraca(ind1,ind2).GT.1.e-10)) THEN
+                mpc_bl_points(ind1,ind2)=1
+            ELSE
+                mpc_bl_points(ind1,ind2)=0
+            ENDIF
+      ENDDO
+
+
+!-------------------------------------------------------------------------------
+! Thermal fraction calculation and standard deviation of the distribution
+!-------------------------------------------------------------------------------  
+
+    DO ind1=1,klon
+
+
+    IF ((ztv(ind1,1).GT.ztv(ind1,2)).AND.(fraca(ind1,ind2).GT.1.e-10)) THEN !Thermal and environnement
+
+
+! Environment:
+
+        zqenv(ind1)=(po(ind1)-fraca(ind1,ind2)*zqta(ind1,ind2))/(1.-fraca(ind1,ind2)) !qt = a*qtth + (1-a)*qtenv
+        Tbef=zthl(ind1,ind2)*zpspsk(ind1,ind2)
+            
+        CALL CALC_QSAT_ECMWF(Tbef,0.,paprs(ind1,ind2),RTT,0,.false.,qsatbef,dqsatdt)
+        zqsatenv(ind1,ind2)=qsatbef
+
+        IF (Tbef .GE. RTT) THEN
+               Lv=RLVTT
+        ELSE
+               Lv=RLSTT
+        ENDIF
+        
+
+        alenv=(0.622*Lv*zqsatenv(ind1,ind2))/(rdd*zthl(ind1,ind2)**2)     !qsl, p84
+        aenv=1./(1.+(alenv*Lv/cppd))                                      !al, p84
+        senv=aenv*(po(ind1)-zqsatenv(ind1,ind2))                          !s, p84
+     
+        ! For MPCs:
+        IF (mpc_bl_points(ind1,ind2) .EQ. 1) THEN
+        CALL CALC_QSAT_ECMWF(Tbef,0.,paprs(ind1,ind2),RTT,1,.false.,qslenv,dqsatdt)
+        alenvl=(0.622*RLVTT*qslenv)/(rdd*zthl(ind1,ind2)**2)     
+        aenvl=1./(1.+(alenv*Lv/cppd))         
+        senvl=aenvl*(po(ind1)-qslenv)    
+        ENDIF
+
+
+! Thermals:
+
+        Tbef=ztla(ind1,ind2)*zpspsk(ind1,ind2)
+        CALL CALC_QSAT_ECMWF(Tbef,0.,paprs(ind1,ind2),RTT,0,.false.,qsatbef,dqsatdt)
+        zqsatth(ind1,ind2)=qsatbef
+
+        IF (Tbef .GE. RTT) THEN
+            Lv=RLVTT
+        ELSE
+            Lv=RLSTT
+        ENDIF
+
+        
+        alth=(0.622*Lv*zqsatth(ind1,ind2))/(rdd*ztla(ind1,ind2)**2)       
+        ath=1./(1.+(alth*Lv/cppd))                                                         
+        sth=ath*(zqta(ind1,ind2)-zqsatth(ind1,ind2))                      
+
+       ! For MPCs:
+        IF (mpc_bl_points(ind1,ind2) .GT. 0) THEN
+         CALL CALC_QSAT_ECMWF(Tbef,0.,paprs(ind1,ind2),RTT,1,.false.,qslth,dqsatdt)
+         CALL CALC_QSAT_ECMWF(Tbef,0.,paprs(ind1,ind2),RTT,2,.false.,qsith,dqsatdt)
+         althl=(0.622*RLVTT*qslth)/(rdd*ztla(ind1,ind2)**2)                    
+         athl=1./(1.+(alth*RLVTT/cppd))                                        
+         sthl=athl*(zqta(ind1,ind2)-qslth)   
+         sthi=athl*(zqta(ind1,ind2)-qsith)  
+        ENDIF     
+
+
+
+!-------------------------------------------------------------------------------
+!  Version 3: Changes by J. Jouhaud; condensation for q > -delta s
+!  Rq: in this subroutine, we assume iflag_clouth_vert .EQ. 3 
+!-------------------------------------------------------------------------------
+
+        IF (mpc_bl_points(ind1,ind2) .EQ. 0) THEN ! No BL MPC
+
+       ! Standard deviation of the distributions
+
+           sigma1s_fraca = (sigma1s_factor**0.5)*(fraca(ind1,ind2)**sigma1s_power) / &
+           &                (1-fraca(ind1,ind2))*((sth-senv)**2)**0.5
+
+           IF (cloudth_ratqsmin>0.) THEN
+             sigma1s_ratqs = cloudth_ratqsmin*po(ind1)
+           ELSE
+             sigma1s_ratqs = ratqs(ind1,ind2)*po(ind1)
+           ENDIF
+ 
+           sigma1s = sigma1s_fraca + sigma1s_ratqs
+           sigma2s=(sigma2s_factor*(((sth-senv)**2)**0.5)/((fraca(ind1,ind2)+0.02)**sigma2s_power))+0.002*zqta(ind1,ind2)
+
+
+           deltasenv=aenv*vert_alpha*sigma1s
+           deltasth=ath*vert_alpha_th*sigma2s
+
+           xenv1=-(senv+deltasenv)/(sqrt(2.)*sigma1s)
+           xenv2=-(senv-deltasenv)/(sqrt(2.)*sigma1s)
+           exp_xenv1 = exp(-1.*xenv1**2)
+           exp_xenv2 = exp(-1.*xenv2**2)
+           xth1=-(sth+deltasth)/(sqrt(2.)*sigma2s)
+           xth2=-(sth-deltasth)/(sqrt(2.)*sigma2s)
+           exp_xth1 = exp(-1.*xth1**2)
+           exp_xth2 = exp(-1.*xth2**2)
+      
+      !surface CF
+
+           cth(ind1,ind2)=0.5*(1.-1.*erf(xth1))
+           cenv(ind1,ind2)=0.5*(1.-1.*erf(xenv1))
+           ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2) 
+
+
+      !volume CF and condensed water
+
+            !environnement
+
+            IntJ=0.5*senv*(1-erf(xenv2))+(sigma1s/sqrt2pi)*exp_xenv2
+            IntJ_CF=0.5*(1.-1.*erf(xenv2))
+
+            IF (deltasenv .LT. 1.e-10) THEN 
+              qcenv(ind1,ind2)=IntJ
+              cenv_vol(ind1,ind2)=IntJ_CF
+            ELSE
+              IntI1=(((senv+deltasenv)**2+(sigma1s)**2)/(8*deltasenv))*(erf(xenv2)-erf(xenv1))
+              IntI2=(sigma1s**2/(4*deltasenv*sqrtpi))*(xenv1*exp_xenv1-xenv2*exp_xenv2)
+              IntI3=((sqrt2*sigma1s*(senv+deltasenv))/(4*sqrtpi*deltasenv))*(exp_xenv1-exp_xenv2)
+              IntI1_CF=((senv+deltasenv)*(erf(xenv2)-erf(xenv1)))/(4*deltasenv)
+              IntI3_CF=(sqrt2*sigma1s*(exp_xenv1-exp_xenv2))/(4*sqrtpi*deltasenv)
+              qcenv(ind1,ind2)=IntJ+IntI1+IntI2+IntI3
+              cenv_vol(ind1,ind2)=IntJ_CF+IntI1_CF+IntI3_CF
+            ENDIF
+             
+
+
+            !thermals
+
+            IntJ=0.5*sth*(1-erf(xth2))+(sigma2s/sqrt2pi)*exp_xth2
+            IntJ_CF=0.5*(1.-1.*erf(xth2))
+     
+            IF (deltasth .LT. 1.e-10) THEN
+              qcth(ind1,ind2)=IntJ
+              cth_vol(ind1,ind2)=IntJ_CF
+            ELSE
+              IntI1=(((sth+deltasth)**2+(sigma2s)**2)/(8*deltasth))*(erf(xth2)-erf(xth1))
+              IntI2=(sigma2s**2/(4*deltasth*sqrtpi))*(xth1*exp_xth1-xth2*exp_xth2)
+              IntI3=((sqrt2*sigma2s*(sth+deltasth))/(4*sqrtpi*deltasth))*(exp_xth1-exp_xth2)
+              IntI1_CF=((sth+deltasth)*(erf(xth2)-erf(xth1)))/(4*deltasth)
+              IntI3_CF=(sqrt2*sigma2s*(exp_xth1-exp_xth2))/(4*sqrtpi*deltasth)
+              qlth(ind1,ind2)=IntJ+IntI1+IntI2+IntI3
+              cth_vol(ind1,ind2)=IntJ_CF+IntI1_CF+IntI3_CF
+            ENDIF
+
+              qctot(ind1,ind2)=fraca(ind1,ind2)*qcth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qcenv(ind1,ind2)
+              ctot_vol(ind1,ind2)=fraca(ind1,ind2)*cth_vol(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv_vol(ind1,ind2)
+              
+
+            IF (cenv(ind1,ind2).LT.1.e-10.or.cth(ind1,ind2).LT.1.e-10) THEN
+                ctot(ind1,ind2)=0.
+                ctot_vol(ind1,ind2)=0.
+                qcloud(ind1)=zqsatenv(ind1,ind2)
+                qincloud(ind1)=0.
+            ELSE               
+                qcloud(ind1)=qctot(ind1,ind2)/ctot(ind1,ind2)+zqs(ind1)
+                qincloud(ind1)=qctot(ind1,ind2)/ctot(ind1,ind2)
+            ENDIF 
+
+
+        ELSE ! mpc_bl_points>0
+
+            ! Treat boundary layer mixed phase clouds
+            
+            ! thermals
+            !=========
+
+            ! ice phase
+            !...........
+
+            deltazlev_mpc=dz(ind1,:)
+            temp_mpc=ztla(ind1,:)*zpspsk(ind1,:)
+            pres_mpc=pplay(ind1,:)
+            fraca_mpc=fraca(ind1,:)
+            snowf_mpc=snowflux(ind1,:)
+            qth_mpc=zqta(ind1,:)
+            flag_topthermals=.FALSE.
+            IF ((mpc_bl_points(ind1,ind2) .EQ. 1) .AND. (mpc_bl_points(ind1,ind2+1) .EQ. 0))  THEN
+                flag_topthermals = .TRUE.
+            ENDIF
+
+            CALL ICE_MPC_BL_CLOUDS(ind1,ind2,klev,flag_topthermals,temp_mpc,pres_mpc,qth_mpc,qlth(ind1,:),qith(ind1,:),deltazlev_mpc,snowf_mpc,fraca_mpc,qiceth)
+
+
+
+            ! We account for the effect of ice crystals in thermals on sthl
+            ! and on the width of the distribution
+
+            sthl=sthl*1./(1.+C_mpc*qiceth)  &
+                + (1.-1./(1.+C_mpc*qiceth)) * athl*(zqta(ind1,ind2)-(qsith+qiceth))  
+
+            sthi=sthi*1./(1.+C_mpc*qiceth)  &
+                + (1.-1./(1.+C_mpc*qiceth)) * athl*(zqta(ind1,ind2)-(qsith+qiceth))  
+
+           ! standard deviation of the water distribution in thermals
+            sth=sthl
+            senv=senvl
+            sigma2s=(sigma2s_factor*((MAX((sth-senv),0.)**2)**0.5)/((fraca(ind1,ind2)+0.02)**sigma2s_power))+0.002*zqta(ind1,ind2)
+            deltasth=athl*vert_alpha_th*sigma2s
+      
+            ! Liquid phase
+            !.............
+            xth1=-(sthl+deltasth)/(sqrt(2.)*sigma2s)
+            xth2=-(sthl-deltasth)/(sqrt(2.)*sigma2s)           
+            exp_xth1 = exp(-1.*xth1**2)
+            exp_xth2 = exp(-1.*xth2**2)
+            IntJ=0.5*sthl*(1-erf(xth2))+(sigma2s/sqrt2pi)*exp_xth2
+            IntJ_CF=0.5*(1.-1.*erf(xth2))
+            IntI1=(((sthl+deltasth)**2+(sigma2s)**2)/(8*deltasth))*(erf(xth2)-erf(xth1))
+            IntI2=(sigma2s**2/(4*deltasth*sqrtpi))*(xth1*exp_xth1-xth2*exp_xth2)
+            IntI3=((sqrt2*sigma2s*(sthl+deltasth))/(4*sqrtpi*deltasth))*(exp_xth1-exp_xth2)
+            IntI1_CF=((sthl+deltasth)*(erf(xth2)-erf(xth1)))/(4*deltasth)
+            IntI3_CF=(sqrt2*sigma2s*(exp_xth1-exp_xth2))/(4*sqrtpi*deltasth)
+            qliqth=IntJ+IntI1+IntI2+IntI3
+
+            ! qimax calculation
+            xth1=-(sthi+deltasth)/(sqrt(2.)*sigma2s)
+            xth2=-(sthi-deltasth)/(sqrt(2.)*sigma2s)           
+            exp_xth1 = exp(-1.*xth1**2)
+            exp_xth2 = exp(-1.*xth2**2)
+            IntJ=0.5*sthi*(1-erf(xth2))+(sigma2s/sqrt2pi)*exp_xth2
+            IntJ_CF=0.5*(1.-1.*erf(xth2))
+            IntI1=(((sthi+deltasth)**2+(sigma2s)**2)/(8*deltasth))*(erf(xth2)-erf(xth1))
+            IntI2=(sigma2s**2/(4*deltasth*sqrtpi))*(xth1*exp_xth1-xth2*exp_xth2)
+            IntI3=((sqrt2*sigma2s*(sthi+deltasth))/(4*sqrtpi*deltasth))*(exp_xth1-exp_xth2)
+            IntI1_CF=((sthi+deltasth)*(erf(xth2)-erf(xth1)))/(4*deltasth)
+            IntI3_CF=(sqrt2*sigma2s*(exp_xth1-exp_xth2))/(4*sqrtpi*deltasth)
+            qimax=IntJ+IntI1+IntI2+IntI3
+            qimax=qimax-qliqth
+
+
+            ! Condensed water
+            ! Guarantee the consistency between qiceth and the subgrid scale PDF of total water
+            qlth(ind1,ind2)=MAX(0.,qliqth)
+            qith(ind1,ind2)=MAX(0.,MIN(qiceth,qimax))
+            qcth(ind1,ind2)=qlth(ind1,ind2)+qith(ind1,ind2)
+
+            ! calculation of qbase which is the value of the water vapor within mixed phase clouds
+            ! such that the total water in cloud = qbase+qliqth+qiceth
+            ! sbase is the value of s such that int_sbase^\intfy s ds = cloud fraction
+            ! sbase and qbase calculation (note that sbase is wrt liq so negative)
+            ! look for an approximate solution with iteration
+            
+            ttarget=qcth(ind1,ind2)
+            mini=athl*(qsith-qslth)
+            maxi=0. 
+            pas=(maxi-mini)/niter
+            stmp=mini
+            sbase=stmp
+            coutref=1.E6
+            DO iter=1,niter
+                cout=ABS(sigma2s/SQRT(2.*RPI)*EXP(-((sthl-stmp)/sigma2s)**2)+(sthl-stmp)/SQRT(2.)*(1.-erf(-(sthl-stmp)/sigma2s)) &
+                     + stmp/2.*(1.-erf(-(sthl-stmp)/sigma2s)) -ttarget)
+               IF (cout .LT. coutref) THEN
+                     sbase=stmp
+                     coutref=cout
+                ELSE
+                     stmp=stmp+pas
+                ENDIF
+            ENDDO
+            qbase=MAX(0., sbase/athl+qslth)
+
+            ! surface cloud fraction in thermals
+            cth(ind1,ind2)=0.5*(1.-erf((sbase-sthl)/sqrt(2.)/sigma2s))
+            cth(ind1,ind2)=MIN(MAX(cth(ind1,ind2),0.),1.)
+
+
+            !volume cloud fraction in thermals
+            !to be checked
+            xth1=-(sthl+deltasth-sbase)/(sqrt(2.)*sigma2s)
+            xth2=-(sthl-deltasth-sbase)/(sqrt(2.)*sigma2s)           
+            exp_xth1 = exp(-1.*xth1**2)
+            exp_xth2 = exp(-1.*xth2**2)
+
+            IntJ=0.5*sthl*(1-erf(xth2))+(sigma2s/sqrt2pi)*exp_xth2
+            IntJ_CF=0.5*(1.-1.*erf(xth2))
+     
+            IF (deltasth .LT. 1.e-10) THEN
+              cth_vol(ind1,ind2)=IntJ_CF
+            ELSE
+              IntI1=(((sthl+deltasth-sbase)**2+(sigma2s)**2)/(8*deltasth))*(erf(xth2)-erf(xth1))
+              IntI2=(sigma2s**2/(4*deltasth*sqrtpi))*(xth1*exp_xth1-xth2*exp_xth2)
+              IntI3=((sqrt2*sigma2s*(sth+deltasth))/(4*sqrtpi*deltasth))*(exp_xth1-exp_xth2)
+              IntI1_CF=((sthl-sbase+deltasth)*(erf(xth2)-erf(xth1)))/(4*deltasth)
+              IntI3_CF=(sqrt2*sigma2s*(exp_xth1-exp_xth2))/(4*sqrtpi*deltasth)
+              cth_vol(ind1,ind2)=IntJ_CF+IntI1_CF+IntI3_CF
+            ENDIF
+              cth_vol(ind1,ind2)=MIN(MAX(0.,cth_vol(ind1,ind2)),1.)
+
+            ! Environment
+            !=============
+            ! In the environment/downdrafts, only liquid clouds
+            ! See Shupe et al. 2008, JAS
+
+            ! standard deviation of the distribution in the environment
+            sth=sthl
+            senv=senvl
+            sigma1s_fraca = (sigma1s_factor**0.5)*(fraca(ind1,ind2)**sigma1s_power) / &
+                          &                (1-fraca(ind1,ind2))*(MAX((sth-senv),0.)**2)**0.5
+            ! for mixed phase clouds, there is no contribution from large scale ratqs to the distribution
+            ! in the environement
+
+            sigma1s_ratqs=1E-10
+            IF (cloudth_ratqsmin>0.) THEN
+                sigma1s_ratqs = cloudth_ratqsmin*po(ind1)
+            ENDIF
+
+            sigma1s = sigma1s_fraca + sigma1s_ratqs
+            deltasenv=aenvl*vert_alpha*sigma1s
+            xenv1=-(senvl+deltasenv)/(sqrt(2.)*sigma1s)
+            xenv2=-(senvl-deltasenv)/(sqrt(2.)*sigma1s)
+            exp_xenv1 = exp(-1.*xenv1**2)
+            exp_xenv2 = exp(-1.*xenv2**2)
+
+            !surface CF
+            cenv(ind1,ind2)=0.5*(1.-1.*erf(xenv1))
+
+            !volume CF and condensed water
+            IntJ=0.5*senvl*(1-erf(xenv2))+(sigma1s/sqrt2pi)*exp_xenv2
+            IntJ_CF=0.5*(1.-1.*erf(xenv2))
+
+            IF (deltasenv .LT. 1.e-10) THEN
+              qcenv(ind1,ind2)=IntJ
+              cenv_vol(ind1,ind2)=IntJ_CF
+            ELSE
+              IntI1=(((senvl+deltasenv)**2+(sigma1s)**2)/(8*deltasenv))*(erf(xenv2)-erf(xenv1))
+              IntI2=(sigma1s**2/(4*deltasenv*sqrtpi))*(xenv1*exp_xenv1-xenv2*exp_xenv2)
+              IntI3=((sqrt2*sigma1s*(senv+deltasenv))/(4*sqrtpi*deltasenv))*(exp_xenv1-exp_xenv2)
+              IntI1_CF=((senvl+deltasenv)*(erf(xenv2)-erf(xenv1)))/(4*deltasenv)
+              IntI3_CF=(sqrt2*sigma1s*(exp_xenv1-exp_xenv2))/(4*sqrtpi*deltasenv)
+              qcenv(ind1,ind2)=IntJ+IntI1+IntI2+IntI3 ! only liquid water in environment
+              cenv_vol(ind1,ind2)=IntJ_CF+IntI1_CF+IntI3_CF
+            ENDIF
+
+            qcenv(ind1,ind2)=MAX(qcenv(ind1,ind2),0.)
+            cenv_vol(ind1,ind2)=MIN(MAX(cenv_vol(ind1,ind2),0.),1.)
+
+
+            
+            ! Thermals + environment 
+            ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2) 
+            qctot(ind1,ind2)=fraca(ind1,ind2)*qcth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qcenv(ind1,ind2)
+            ctot_vol(ind1,ind2)=fraca(ind1,ind2)*cth_vol(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv_vol(ind1,ind2)
+            IF (qcth(ind1,ind2) .GT. 0) THEN
+                icefrac(ind1,ind2)=fraca(ind1,ind2)*qith(ind1,ind2)/(fraca(ind1,ind2)*qcth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qcenv(ind1,ind2))
+                icefrac(ind1,ind2)=MAX(MIN(1.,icefrac(ind1,ind2)),0.)
+            ELSE
+                icefrac(ind1,ind2)=0.
+            ENDIF
+
+            IF (cenv(ind1,ind2).LT.1.e-10.or.cth(ind1,ind2).LT.1.e-10) THEN
+                ctot(ind1,ind2)=0.
+                ctot_vol(ind1,ind2)=0.
+                qincloud(ind1)=0.
+                qcloud(ind1)=zqsatenv(ind1,ind2)
+            ELSE               
+                qcloud(ind1)=fraca(ind1,ind2)*(qcth(ind1,ind2)/cth(ind1,ind2)+qbase) &
+                            +(1.-1.*fraca(ind1,ind2))*(qcenv(ind1,ind2)/cenv(ind1,ind2)+qslenv)
+                qincloud(ind1)=MAX(fraca(ind1,ind2)*(qcth(ind1,ind2)/cth(ind1,ind2)) &
+                            +(1.-1.*fraca(ind1,ind2))*(qcenv(ind1,ind2)/cenv(ind1,ind2)),0.)
+            ENDIF 
+
+        ENDIF ! mpc_bl_points
+
+
+    ELSE  ! gaussian for environment only
+
+      
+        zqenv(ind1)=po(ind1)
+        Tbef=temp(ind1,ind2)
+
+        CALL CALC_QSAT_ECMWF(Tbef,0.,paprs(ind1,ind2),RTT,0,.false.,qsatbef,dqsatdt)
+        zqsatenv(ind1,ind2)=qsatbef
+
+        IF (Tbef .GE. RTT) THEN
+                Lv=RLVTT
+        ELSE
+                Lv=RLSTT
+        ENDIF
+        
+
+        zthl(ind1,ind2)=temp(ind1,ind2)*(101325./paprs(ind1,ind2))**(rdd/cppd)
+        alenv=(0.622*Lv*zqsatenv(ind1,ind2))/(rdd*zthl(ind1,ind2)**2)
+        aenv=1./(1.+(alenv*Lv/cppd))
+        senv=aenv*(po(ind1)-zqsatenv(ind1,ind2))
+        sth=0.
+      
+        sigma1s=ratqs(ind1,ind2)*zqenv(ind1)
+        sigma2s=0.
+
+        sqrt2pi=sqrt(2.*pi)
+        xenv=senv/(sqrt(2.)*sigma1s)
+        ctot(ind1,ind2)=0.5*(1.+1.*erf(xenv))
+        ctot_vol(ind1,ind2)=ctot(ind1,ind2)
+        qctot(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))
+      
+        IF (ctot(ind1,ind2).LT.1.e-3) THEN
+          ctot(ind1,ind2)=0.
+          qcloud(ind1)=zqsatenv(ind1,ind2)
+          qincloud(ind1)=0.
+        ELSE 
+          qcloud(ind1)=qctot(ind1,ind2)/ctot(ind1,ind2)+zqsatenv(ind1,ind2)
+          qincloud(ind1)=MAX(qctot(ind1,ind2)/ctot(ind1,ind2),0.)
+        ENDIF
+ 
+
+    ENDIF       ! From the separation (thermal/envrionnement) and (environnement only,) l.335 et l.492
+
+    ! Outputs used to check the PDFs
+    cloudth_senv(ind1,ind2) = senv
+    cloudth_sth(ind1,ind2) = sth
+    cloudth_sigmaenv(ind1,ind2) = sigma1s
+    cloudth_sigmath(ind1,ind2) = sigma2s
+
+
+    ENDDO       !loop on klon 
+
+RETURN
+
+
+END SUBROUTINE cloudth_mpc
+
+!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+SUBROUTINE ICE_MPC_BL_CLOUDS(ind1,ind2,klev,flag_topthermals,temp,pres,qth,qlth,qith,deltazlev,snowf,fraca,qi)
+
+! parameterization of ice for boundary
+! layer mixed-phase clouds assuming a stationary system
+!
+! Note that vapor deposition on ice crystals and riming of liquid droplets
+! depend on the ice number concentration Ni
+! One could assume that Ni depends on qi, e.g.,  Ni=beta*(qi*rho)**xi
+! and use values from Hong et al. 2004, MWR for instance
+! One may also estimate Ni as a function of T, as in Meyers 1922 or Fletcher 1962 
+! One could also think of a more complex expression of Ni;
+! function of qi, T, the concentration in aerosols or INP ..
+! Here we prefer fixing Ni to a tuning parameter
+! By default we take 2.0L-1=2.0e3m-3, median value from measured vertical profiles near Svalbard
+! in Mioche et al. 2017
+!
+!
+! References:
+!------------
+! This parameterization is thoroughly described in Vignon et al. 
+!
+! More specifically
+! for the Water vapor deposition process:
+!
+! Rotstayn, L. D., 1997: A physically based scheme for the treat-
+! ment of stratiform cloudfs and precipitation in large-scale
+! models. I: Description and evaluation of the microphysical
+! processes. Quart. J. Roy. Meteor. Soc., 123, 1227–1282.
+!
+!  Morrison, H., and A. Gettelman, 2008: A new two-moment bulk
+!  stratiform cloud microphysics scheme in the NCAR Com-
+!  munity Atmosphere Model (CAM3). Part I: Description and
+!  numerical tests. J. Climate, 21, 3642–3659
+!
+! for the Riming process:
+!
+! Rutledge, S. A., and P. V. Hobbs, 1983: The mesoscale and micro-
+! scale structure and organization of clouds and precipitation in
+! midlatitude cyclones. VII: A model for the ‘‘seeder-feeder’’
+! process in warm-frontal rainbands. J. Atmos. Sci., 40, 1185–1206
+!
+! Thompson, G., R. M. Rasmussen, and K. Manning, 004: Explicit
+! forecasts of winter precipitation using an improved bulk
+! microphysics scheme. Part I: Description and sensitivityThompson, G., R. M. Rasmussen, and K. Manning, 2004: Explicit
+! forecasts of winter precipitation using an improved bulk
+! microphysics scheme. Part I: Description and sensitivity analysis. Mon. Wea. Rev., 132, 519–542
+!
+! For the formation of clouds by thermals:
+!
+! Rio, C., & Hourdin, F. (2008). A thermal plume model for the convective boundary layer : Representation of cumulus clouds. Journal of
+! the Atmospheric Sciences, 65, 407–425.
+!
+! Jam, A., Hourdin, F., Rio, C., & Couvreux, F. (2013). Resolved versus parametrized boundary-layer plumes. Part III: Derivation of a
+! statistical scheme for cumulus clouds. Boundary-layer Meteorology, 147, 421–441. https://doi.org/10.1007/s10546-012-9789-3
+!
+!
+!
+! Contact: Etienne Vignon, etienne.vignon@lmd.ipsl.fr
+!=============================================================================
+
+    USE lscp_tools_mod, ONLY: CALC_QSAT_ECMWF
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE phys_state_var_mod, ONLY : fm_therm, detr_therm, entr_therm
+
+    IMPLICIT none
+
+
+    INCLUDE "YOMCST.h"
+    INCLUDE "nuage.h"
+
+    INTEGER, INTENT(IN) :: ind1,ind2, klev ! horizontal and vertical indices and dimensions
+    LOGICAL, INTENT(IN) :: flag_topthermals ! uppermost layer of thermals ?
+    REAL,  DIMENSION(klev), INTENT(IN) :: temp       ! temperature [K] within thermals
+    REAL,  DIMENSION(klev), INTENT(IN) :: pres       ! pressure [Pa]
+    REAL,  DIMENSION(klev), INTENT(IN) :: qth        ! mean specific water content in thermals [kg/kg]
+    REAL,  DIMENSION(klev), INTENT(IN) :: qlth       ! condensed liquid water in thermals, approximated value [kg/kg]
+    REAL,  DIMENSION(klev), INTENT(IN) :: qith       ! condensed ice water , thermals [kg/kg]
+    REAL,  DIMENSION(klev), INTENT(IN) :: deltazlev  ! layer thickness [m]
+    REAL,  DIMENSION(klev+1), INTENT(IN) :: snowf      ! snow flux at the upper inferface
+    REAL,  DIMENSION(klev+1), INTENT(IN) :: fraca      ! fraction of the mesh covered by thermals
+
+    REAL,  INTENT(OUT) :: qi        ! ice cloud specific content [kg/kg]
+
+
+    REAL, SAVE    :: Ni,  C_cap, Ei, d_top
+    !$OMP THREADPRIVATE(Ni, C_cap,Ei, d_top)
+    LOGICAL, SAVE :: firstcall = .TRUE.
+    !$OMP THREADPRIVATE(firstcall)
+
+
+    INTEGER ind2p1,ind2p2
+    REAL rho(klev)
+    REAL unsurtaudet, unsurtaustardep, unsurtaurim
+    REAL qsl, qsi, dqs, AA, BB, Ka, Dv, rhoi
+    REAL  p0, t0
+    REAL alpha, flux_term
+    REAL det_term, precip_term, rim_term, dep_term
+
+  
+    IF (firstcall) THEN
+        Ni=2.0e3
+        CALL getin_p('Ni', Ni)
+        WRITE(*,*) 'Ni = ', Ni
+
+        Ei=0.5
+        CALL getin_p('Ei', Ei)
+        WRITE(*,*) 'Ei = ', Ei
+
+        C_cap=0.5
+        CALL getin_p('C_cap', C_cap)
+        WRITE(*,*) 'C_cap = ', C_cap
+
+        d_top=0.8
+        CALL getin_p('d_top', d_top)
+        WRITE(*,*) 'd_top = ', d_top
+
+
+        firstcall=.FALSE.
+    ENDIF
+
+
+    ind2p1=ind2+1
+    ind2p2=ind2+2
+
+    ! Liquid water content:
+    !=====================
+    ! the liquid water content is not calculated in this routine
+
+    ! Ice water content
+    ! ==================
+
+    rho=pres/temp/RD  ! air density kg/m3
+
+    Ka=2.4e-2      ! thermal conductivity of the air, SI
+    p0=101325.0    ! ref pressure
+    T0=273.15      ! ref temp
+    rhoi=500.0     ! cloud ice density following Reisner et al. 1998
+    alpha=700.     ! fallvelocity param
+
+
+    IF (flag_topthermals) THEN ! uppermost thermals level, solve a third order polynomial with Cardan's method
+
+    Dv=0.0001*0.211*(p0/pres(ind2))*((temp(ind2)/T0)**1.94) ! water vapor diffusivity in air, SI
+
+    ! Detrainment term:
+    unsurtaudet=detr_therm(ind1,ind2)/rho(ind2)/deltazlev(ind2)
+ 
+    ! vertical flux
+    
+    flux_term=d_top*fm_therm(ind1,ind2)/deltazlev(ind2)
+
+    ! Deposition term
+    CALL CALC_QSAT_ECMWF(temp(ind2),0.,pres(ind2),RTT,2,.false.,qsi,dqs)
+    CALL CALC_QSAT_ECMWF(temp(ind2),0.,pres(ind2),RTT,1,.false.,qsl,dqs)
+    AA=RLSTT/Ka/temp(ind2)*(RLSTT/RV/temp(ind2)-1.)
+    BB=1./(rho(ind2)*Dv*qsi)
+    unsurtaustardep=C_cap*(Ni**0.66)*(qsl-qsi)/qsi*4.*RPI/(AA+BB)*(6.*rho(ind2)/rhoi/RPI/Gamma(4.))**(0.33)
+
+    ! Riming term  neglected at this level
+    !unsurtaurim=rho(ind2)*alpha*3./rhoi/2.*Ei*qlth(ind2)*((p0/pres(ind2))**0.4)
+
+    qi=rho(ind2)*unsurtaustardep/MAX((rho(ind2)*unsurtaudet-flux_term),1E-12)
+    qi=MAX(qi,0.)**(3./2.)
+
+    ELSE ! other levels, estimate qi(k) from variables at k+1 and k+2
+
+    Dv=0.0001*0.211*(p0/pres(ind2p1))*((temp(ind2p1)/T0)**1.94) ! water vapor diffusivity in air, SI
+
+    ! Detrainment term:
+
+    unsurtaudet=detr_therm(ind1,ind2p1)/rho(ind2p1)/deltazlev(ind2p1)
+    det_term=-unsurtaudet*qith(ind2p1)*rho(ind2p1)
+    
+    
+    ! Deposition term
+
+    CALL CALC_QSAT_ECMWF(temp(ind2p1),0.,pres(ind2p1),RTT,2,.false.,qsi,dqs)
+    CALL CALC_QSAT_ECMWF(temp(ind2p1),0.,pres(ind2p1),RTT,1,.false.,qsl,dqs)
+    AA=RLSTT/Ka/temp(ind2p1)*(RLSTT/RV/temp(ind2p1)-1.)
+    BB=1./(rho(ind2p1)*Dv*qsi)
+    unsurtaustardep=C_cap*(Ni**0.66)*(qsl-qsi)/qsi*4.*RPI/(AA+BB)*(6.*rho(ind2p1)/rhoi/RPI/Gamma(4.))**(0.33)
+    dep_term=rho(ind2p1)*(qith(ind2p1)**0.33)*unsurtaustardep
+ 
+    ! Riming term
+
+    unsurtaurim=rho(ind2p1)*alpha*3./rhoi/2.*Ei*qlth(ind2p1)*((p0/pres(ind2p1))**0.4)
+    rim_term=rho(ind2p1)*qith(ind2p1)*unsurtaurim
+
+    ! Precip term
+
+    !precip_term=-1./deltazlev(ind2p1)*(fraca(ind2p2)*snowf(ind2p2)-fraca(ind2p1)*snowf(ind2p1))
+    ! We assume that there is no solid precipitation outside thermals (so no multiplication by fraca)
+    precip_term=-1./deltazlev(ind2p1)*(snowf(ind2p2)-snowf(ind2p1))
+
+    ! Calculation in a top-to-bottom loop
+
+    IF (fm_therm(ind1,ind2p1) .GT. 0.) THEN
+       qi= 1./fm_therm(ind1,ind2p1)* &
+          (deltazlev(ind2p1)*(-rim_term-dep_term-det_term-precip_term) + &
+          fm_therm(ind1,ind2p2)*(qith(ind2p1)))
+    ELSE
+       qi=0.
+    ENDIF
+
+    ENDIF ! flag_topthermals
+  
+    qi=MAX(0.,qi)
+
+    RETURN
+
+END SUBROUTINE ICE_MPC_BL_CLOUDS
+
+
+
+
 END MODULE cloudth_mod
 
